package com.jcg;

import java.util.HashMap;
import java.util.Map;

import javax.naming.Context;

import org.apache.camel.EndpointInject;
import org.apache.camel.builder.RouteBuilder;
import org.apache.camel.component.dataset.SimpleDataSet;
import org.apache.camel.component.mock.MockEndpoint;
import org.apache.camel.test.junit4.CamelTestSupport;
import org.junit.Test;

public class CustomLoadBalance extends CamelTestSupport{
	
	@EndpointInject(uri="mock:m1")
	MockEndpoint m1;
	@EndpointInject(uri="mock:m2")
	MockEndpoint m2;
	@EndpointInject(uri="mock:end")
	MockEndpoint end;
	
	@Override
	protected RouteBuilder createRouteBuilder() throws Exception{
		return new RouteBuilder(){
			@Override
			public void configure() throws Exception {
				from("dataset:start").loadBalance(new SessionChecker()).to(m1,m2).end().to(end);
			}
		};
	}
	
	@Override
	protected Context createJndiContext() throws Exception{
		SimpleDataSet sds = new SimpleDataSet();
		Map<String, Object> headers = new HashMap<>();
		headers.put("sessionID", 1);
		sds.setDefaultHeaders(headers);
		sds.setSize(2);
		Context context = super.createJndiContext();
		context.bind("start", sds);
		return context;
	}
	
	@Test
	public void testSending() throws Exception{	
		m1.expectedMessageCount(0);
		m2.expectedMessageCount(2);
		end.expectedMessageCount(2);
		template.sendBody("dataset:start", "");
		m1.assertIsSatisfied();
		m2.assertIsSatisfied();
		end.assertIsSatisfied();
	}
}
