package com.jcg;

import org.apache.camel.EndpointInject;
import org.apache.camel.builder.RouteBuilder;
import org.apache.camel.component.mock.MockEndpoint;
import org.apache.camel.test.junit4.CamelTestSupport;
import org.junit.Test;

public class RandomLoadBalance extends CamelTestSupport{
	@EndpointInject(uri="mock:m1")
	MockEndpoint m1;
	@EndpointInject(uri="mock:m2")
	MockEndpoint m2;
	@EndpointInject(uri="mock:m3")
	MockEndpoint m3;
	@EndpointInject(uri="mock:end")
	MockEndpoint end;

	@Override
	protected RouteBuilder createRouteBuilder() throws Exception{
		return new RouteBuilder(){
			@Override
			public void configure() throws Exception {
				from("direct:start").loadBalance().random().to(m1,m2,m3).end().to(end);
			}
			
		};
	}
	
	@Test
	public void testSending() throws Exception{
		end.expectedMessageCount(1);
		template.sendBody("direct:start", "");
		end.assertIsSatisfied();
	}
}
